/**
 * $Id: tfsp_errno.h 3672 2013-04-10 04:21:12Z yone $
 *
 * TeamFileץ饰SDKѥإåե(ơɡ顼)
 */
#ifndef INCLUDE_TFSP_ERRNO_H
#define INCLUDE_TFSP_ERRNO_H

#include "tfsp.h"
#include "tfs_errno.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Fixed values and Define Macro
  ----------------------------------------------------------------------------*/
/**
 * ХѿĴԤdefine ͤ
 */
#ifdef TFSP_ERRMSG_GLOBAL_VALUE_DEFINE
#define TFSP_ERRMSG_GLOBAL
#else
#define TFSP_ERRMSG_GLOBAL extern
#endif  /* TFSP_ERRMSG_GLOBAL_VALUE_DEFINE */

/*------------------------------------------------------------------------------
  Define error code
  ----------------------------------------------------------------------------*/
/**
 * (note) ĤΥ顼ɤOSΥ顼֤εˤĤ
 *
 *	顼ȯȤθ礭ʬưʲ2̤ꤢ.
 *
 *		1. ͤ˥ޥåʤä˵顼
 *		2. API(OSʤ)ֵѤ줿顼
 *	
 *	Υ顼ηϤϰۤʤΤǡϻͥ顼
 *	OS顼֤ȤǤʤ
 *	뤿ᡢʲˤ˴ŤƼ뤳ȡ
 *
 *  (1) ץ饰ѥ顼ɤ
 *	(2) OS ֵѤ륨顼ɤˤĤƤϥХͤ­
 *
 * ʾˤꡢŬڤ˥ХͤĴƤСOSΥ顼ɤ
 * ץ饰Υ顼ɤХåƥ󥰤뤳Ȥ̵ʤ롣
 */

/**
 * ץ饰ͤ˴Ť顼ɤΥХ
 */
#define TFSP_SPEC_START_ERRNO	10000

/**
 * ץ饰ͭΥ顼ɤΥХ
 * ץ饰Ѥ饤ֵ֥꤫Ѥ줿顼ɤʤɡ
 */
#define TFSP_PLUGIN_START_ERRNO	20000

/* 顼ɤȤΩƤޥ */
#define TFSP_PLUGIN_ERRNO(code)	(TFSP_PLUGIN_START_ERRNO + (code))

/**
 * OSͭΥ顼ɤΥХ͡
 *
 * ͤOS顼ɤ­줿ͤȤƥ顼ɤޤ
 * (see errno.h)
 */
#define TFSP_OS_START_ERRNO	30000

/* 顼ɤȤΩƤޥ */
#define TFSP_OS_ERRNO(code)	(TFSP_OS_START_ERRNO + (code))

/**
 * ѥ桼ƥƥ顼ɤΥХ
 */
#define TFSP_UTIL_START_ERRNO	40000

/* 顼ɤȤΩƤޥ */
#define TFSP_UTIL_ERRNO(code)	(TFSP_UTIL_START_ERRNO + (code))

/*
 * 顼ɤ饪ꥸʥ륨顼ɤޥ
 */
#define TFSP_NATIVE_ERRNO(code)	\
	((code < TFSP_SPEC_START_ERRNO) ? code : ((TFSP_PLUGIN_START_ERRNO <= code && code < TFSP_OS_START_ERRNO) ? ((code) - TFSP_PLUGIN_START_ERRNO) : ((TFSP_OS_START_ERRNO <= code && code < TFSP_UTIL_START_ERRNO) ? (code - TFSP_OS_START_ERRNO) : ((FSP_UTIL_START_ERRNO <= code) ? (code - FSP_UTIL_START_ERRNO) : code))))

/**
 * 顼ɰ
 */
enum {
	TFSP_SUCCESS = 0,	/*  */
	TFSP_DECLINE,		/* ץ饰νоݳäΤǡ򤷤ʤ */
	TFSP_NOPROCESS,		/* оݤǤϤä˥ޥåʤäΤǽʤä */
	TFSP_ERR = TFSP_SPEC_START_ERRNO + 1,	/* ͽʤͳǼԤ */
	TFSP_EINVALID_PARAM,	/* ͤ */
	TFSP_ENOPARAM,			/* ɬפ̵ͤä */
	TFSP_ENOCTX,			/* ƥȥ֥Ȥ̵ä */
	TFSP_ENOVALUE,          /* ɬͤʤä */
	TFSP_EUNSUPPORTED_FOLDER,	/* оݳΥե̤ꤵ줿 */
	TFSP_ENOPLUGINROOTDIR,	/* оݥǥ쥯ȥϥץ饰롼ȥǥ쥯ȥǤϤʤä */
	TFSP_ENOLOADERCONF,		/* ץ饰ѥեե뤬ʤä */
	TFSP_ELOADERCONF_READ,	/* ץ饰ѥեեɤ߹ߤ˼Ԥ */
	TFSP_ENOPLUGINDIR,		/* оݥǥ쥯ȥϥץ饰ǥ쥯ȥǤϤʤä */
	TFSP_EINVALID_PLUGINCONF,	/* ץ饰󥳥եեξ֤ʤä   */
	TFSP_EEMPTYELEM_PLUGINCONF,	/* ץ饰󥳥եͭʥȤʤä */
	TFSP_ELOADPLUGIN,		/* ץ饰ͭ饤֥Υǥ󥰤˼Ԥ */
	TFSP_ENOTLOADABLE,		/* ʥߥåǥ󥰲ǽʥ饤֥ǤϤʤ */
	TFSP_EUNLOADPLUGIN,		/* ץ饰饤֥򥢥ɤǤʤä */
	TFSP_ENOPLUGIN,			/* оݤΥץ饰¸ߤʤä */
};

/*------------------------------------------------------------------------------
  Define error message
  ----------------------------------------------------------------------------*/
TFSP_ERRMSG_GLOBAL const tfs_err_elem tfsp_error_map[]
#ifdef TFSP_ERRMSG_GLOBAL_VALUE_DEFINE
= {
	{ TFSP_SUCCESS,	"Success"	},
	{ TFSP_DECLINE, "Decline this request" },
	{ TFSP_EERR,	"Unexptected Error"	},
	{ TFSP_EINVALID_PARAM,	"Invalid parameters"	},
	{ TFSP_ENOPARAM,	"Parameter was missing."	},
	{ TFSP_ENOCTX,	"Context was missing"	},
	{ TFSP_ENOVALUE,	"The value was EMPTY."	},
	{ TFSP_EUNSUPPORTED_FOLDER,	"Unsupported folder specified"	},
	{ TFSP_ENOPLUGINROOTDIR,	"This dir is not plugin root dir"	},
	{ TFSP_ENOLOADERCONF,	"The plugin loader config file was missing"	},
	{ TFSP_ELOADERCONF_READ,	"Failed to read loader config xml"	},
	{ TFSP_ENOPLUGINDIR,	"This dir is not plugin's dir"	},
	{ TFSP_EINVALID_PLUGINCONF,	"The plugin's config file was not valid."	},
	{ TFSP_ELOADPLUGIN,	"Failed to load plugin's shared library"	},
	{ TFSP_ENOTLOADABLE,	"We could not load this type of file"	},
	{ TFSP_EUNLOADPLUGIN,	"Failed to unload plugin's shared library"	},
	{ TFSP_ENOPLUGIN,	"The plugin not found."	},
}
#endif	/* TFSP_ERRMSG_GLOBAL_VALUE_DEFINE */
;

#ifdef TFSP_ERRMSG_GLOBAL_VALUE_DEFINE
#define TFSP_ERRMSG_MAP_LEN	sizeof(tfsp_error_map)/sizeof(tfs_err_elem)
#else
#define TFSP_ERRMSG_MAP_LEN 0
#endif	/* TFSP_ERRMSG_GLOBAL_VALUE_DEFINE */

/*------------------------------------------------------------------------------
  Declare public functions
  ----------------------------------------------------------------------------*/
/**
 * 顼ɤ򥨥顼åѴ.
 *
 * @param rv tfs_status_t ơ
 * @param const char * const 顼å
 *		åȤ񤭴ƤϤʤޤ
 *		ʸƥʤΤCoreDumpޤ.
 */
/*TFS_DECLARE(const char * const) tfsp_errcd2str(tfs_status_t rv); */


#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFSP_ERRNO_H */

