/**
 * $Id: tfsp_ihdr_ccipher.h 1393 2006-03-06 19:05:20Z takehara $
 *
 * TeamFileץ饰SDKѥإåե(ץ饰ϥɥ)
 * (note)
 *	ƥץ饰ϤΥإåեɬincludeƲ
 */
#ifndef INCLUDE_TFSP_IHDR_CCIPHER_H
#define INCLUDE_TFSP_IHDR_CCIPHER_H

#include "tfsp_ihdr.h"
#include "tfs_errlog.h"
#include "tfs_pools.h"
#include "tfs_hashset.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Fixed values and Define Macro
  ----------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------
  Define structure/enum
  ----------------------------------------------------------------------------*/
typedef struct tfsp_ihdr_ccipher    tfsp_ihdr_ccipher;
typedef struct tfsp_ctx_ccipher     tfsp_ctx_ccipher;
typedef struct tfsp_ccipher_file    tfsp_ccipher_file;

/**
 * TeamFile ΰŹץ饰󥤥󥿡ե¤Τ
 */
struct tfsp_ihdr_ccipher {
	/**
	 * TeamFileХץ饰١󥿡եؤΥݥ
	 */
	const tfsp_ihdr_base *bs;

	/**
	 * ΰŹ沽ν 󥿡ե
	 * [  ]
	 *   * ΰŹ沽ΩŹ沽μ»ܤɬפʥ꥽ν.
	 *   * 1ٽ顢֥եŹ沽νλפ¹Ԥޤ
	 *     ΰŹ沽Ѳǽ
	 *
	 * @param p tfs_pool_t * ꥢ. NULL ʤмȤ.
	 * @param ctx tfsp_ctx_ccipher * ƥȤؤΥݥ
	 *            ctx ΥȤϸƤӽФǼ».
	 *            ctx->child ˤcinit η̤.
	 * @param tfs_error_t * 顼ơ (NULL )
	 * 	顼ϺǸ˼ΤƤƤ.
	 */
	tfs_error_t * (*prepare)(tfs_pool_t *p, tfsp_ctx_ccipher *ctx);

	/**
	 * Ϳ줿եμΰŹ沽 󥿡ե
	 * [  ]
	 *   * ΰŹ沽μ»
	 *
	 * @param ctx tfsp_ctx_ccipher * ƥȤؤΥݥ
	 * @param file tfsp_ccipher_file *
	 * @return tfs_error_t * 顼ơ (NULL )
	 * 	顼ϺǸ˼ΤƤƤ.
	 */
	tfs_error_t * (*ccipher)(tfsp_ctx_ccipher *ctx, tfsp_ccipher_file *file);

	/**
	 * ΰŹ沽оݤȤʤ륰롼IDΰ뤿Υ󥿡ե
	 *
	 * @param ctx tfsp_ctx_ccipher * ƥȤؤΥݥ
	 * @param groupid_set tfs_hset_t ** 롼IDʤ륻å
	 * @return tfs_error_t * 顼ơ (NULL )
	 * 	顼ϺǸ˼ΤƤƤ.
	 */
	tfs_error_t * (*cipheredGroupSet)(tfsp_ctx_ccipher *ctx, tfs_hset_t **groupid_set);

	/**
	 * ΰŹ沽оݤꤵ줿롼IDΥ롼פ.
	 *
	 * @param ctx tfsp_ctx_ccipher * ƥȤؤΥݥ
	 * @param groupid const char * 롼ID
	 * @return tfs_error_t * 顼ơ (NULL )
	 * 	顼ϺǸ˼ΤƤƤ.
	 */
	tfs_error_t * (*excludeTarget)(tfsp_ctx_ccipher *ctx, const char *groupid);

	/**
	 * ΰŹ沽νλ 󥿡ե
	 * [  ]
	 *   * ΰŹ沽Ѥ줿꥽γ
	 *
	 * @param ctx tfsp_ctx_ccipher * ƥȤؤΥݥ
	 */
	void (*release)(tfsp_ctx_ccipher *ctx);

	/* ߡ. ץ饰Ф˿ʤ. */
	void *reserved1;
	void *reserved2;
	void *reserved3;
	void *reserved4;
	void *reserved5;
};

/**
 * ΰŹ沽Ѥ륳ƥȹ¤Τ
 */
struct tfsp_ctx_ccipher {
	/**
	 * ҥץ٥륳ƥȹ¤ΤؤΥݥ
	 * cinit ΤǤ.
	 */
	const tfsp_ctx_child *child;

	/**
	 * оݤȤʤLocation ̾(Apache ѤΤ)
	 */
	const char *location;

	/**
	 * ǤդΥǡؤΥݥ (see GET_PRIVATE_CTX ޥ)
	 *
	 * ץ饰󤬾˻ȤäƲ. ʳ뤳ȤϤޤ.
	 */
	void *d;
};

/**
 * ΰŹ沽ܤե˴ؤݻ빽¤Τ
 */
struct tfsp_ccipher_file {

	/* Ͼ */
	const char *path;			/* ʪեΥեѥ */
	const char *name;			/* եɽ̾       */
	const char *ctype;			/* եContent-Type */
	tfsp_type_operation op;		/* ڥ졼μ   */
	tfsp_type_folder srctype;	/* ե(src)      */
	tfsp_type_folder dsttype;	/* ե(dst)      */
	int keep_inputfile;			/* ϥե򤽤Τޤްݻ뤫ɤ */
	const char *groupid;        /* Υե򥢥åץɤ륰롼פID */

	/* Ͼ */
	char *opath;			/* եΥեѥ     */
	char *oname;			/* եɽ̾       */
	const char *octype;		/* եContent-Type */
	tfs_int64_t ofsize;		/* ե륵         */
};

/*------------------------------------------------------------------------------
  Declare public functions
  ----------------------------------------------------------------------------*/

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFSP_IHDR_CCIPHER_H */

