/**
 * $Id: tfsp_loader.h 2180 2007-08-30 06:04:49Z takehara $
 *
 * TeamFileץ饰SDKѥإåե(ץ饰)
 * (note)
 *   Υإåե줿ѿϡץ饰饤֥
 *   ǥ󥰤ŪǻѤޤ.
 *   äơץ饰饤֥꼫ȤΥإåinclude ƤϤʤޤ.
 */
#ifndef TFSP_CORE_PRIVATE
# error "Never include <tfsp_loader.h> except TeamFile Core module."
#endif	/* TFSP_CORE_PRIVATE */

#ifndef INCLUDE_TFSP_LOADER_H
#define INCLUDE_TFSP_LOADER_H

#include "tfsp.h"
#include "tfsp_errno.h"
#include "tfsp_ihdr.h"

#include "tfs_errlog.h"
#include "tfs_varray.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Fixed values and Define Macro
  ----------------------------------------------------------------------------*/
/**
 * ץ饰ѥեե̾
 */
#define TFSP_LOADER_CONFFILE	"config.xml"

/**
 * ץ饰ѥեե̾
 */
#define TFSP_PLUGIN_CONFFILE	"plugin.xml"

/*------------------------------------------------------------------------------
  Define structures and enum
  ----------------------------------------------------------------------------*/
typedef struct tfsp_plugin_module     tfsp_plugin_module;
typedef struct tfsp_if_version        tfsp_if_version;
typedef struct tfsp_interface_info    tfsp_interface_info;
typedef struct tfsp_author_info       tfsp_author_info;
typedef struct tfsp_plugin_fileinfo	  tfsp_plugin_fileinfo;
typedef struct tfsp_plugin_cpageinfo  tfsp_plugin_cpageinfo;
typedef struct tfsp_plugin_cpage      tfsp_plugin_cpage;
typedef struct tfsp_plugin_state      tfsp_plugin_state;

/**
 * ץ饰󤬥ݡȤ륤󥿡եμɽ
 */
typedef enum tfsp_if_type	tfsp_if_type;
enum tfsp_if_type {
	TFSP_IFTYPE_UNKNOWN = 0,	/* (̤) */
	TFSP_IFTYPE_CCIOHER,		/* ΰŹ沽 */
	TFSP_IFTYPE_FFILTER,		/* ե̾ե륿 */
};

/**
 * ץ饰μ󶡤륪֥Ȥμ
 */
typedef enum tfsp_if_filetype	tfsp_if_filetype;
enum tfsp_if_filetype {
	TFSP_IFFTYPE_UNKNOWN = 0,	/* ̤ */
	TFSP_IFFTYPE_SHAREDOBJ,		/* ʥߥåǥ󥰲ǽʶͭ饤֥ */
	TFSP_IFFTYPE_CGISCRIPT,		/* CGIץ */
};

/**
 * ץ饰⥸塼륳ƥȹ¤ [ Դ ]
 */
typedef struct tfsp_plugin_modulectx  tfsp_plugin_modulectx;

/**
 * ġΥץ饰ɽ¤
 */
struct tfsp_plugin_module {

	char *name;		/* ץ饰̾ */
	char *version;	/* ץ饰ΥСֹ */
	char *summary;	/* ץ饰ûʸ */
	char *description;	/* ץ饰ξܺ٤ʸ */

	/* 󥿡ե */
	tfsp_interface_info *if_info;

	/* Ծ */
	tfsp_author_info *author;

	/* ե */
	tfsp_plugin_fileinfo *fileinfo;

	/* եڡξ */
	tfsp_plugin_cpageinfo *cpageinfo;

	/*  */
	tfsp_plugin_state *state;

	const char *pluginpath;	/* ץ饰ǥ쥯ȥΥѥ */
	const char *confpath;	/* ץ饰󥳥եեΥѥ */

	/* ץ饰ѤѤ륳ƥȤؤΥݥ */
	tfsp_plugin_modulectx *ctx;

	tfsp_plugin_module *next;	/* Ϣץ饰ؤΥݥ(ͽ) */
};

/**
 * 󥿡եСɽ¤
 */
struct tfsp_if_version {
	tfs_int32_t current;
	tfs_int32_t revision;
	tfs_int32_t age;
};

/**
 * ݡ/Ƥ륤󥿡եɽ¤
 */
struct tfsp_interface_info {
	/* ݡȥ󥿡եμ */
	tfsp_if_type itype;

	/* ݡȥ󥿡եΥС */
	tfsp_if_version *iversion;
};

/**
 * Ծɽ¤
 */
struct tfsp_author_info {
	char *vender;
	char *copyright;
	char *homepageurl;
	char *mailaddress;
};

/**
 * ץ饰Υե˴ؤɽ¤
 */
struct tfsp_plugin_fileinfo {
	/* ץ饰եΥѥ */
	char *filepath;

	/* ץ饰եμ */
	tfsp_if_filetype ftype;

	/* ץ饰եΥå(MD5) */
	char *checksum;
};

/**
 * եڡΤξɽ¤
 */
struct tfsp_plugin_cpageinfo {
	tfsp_plugin_cpage *g_cpuri;
	tfsp_plugin_cpage *l_cpuri;
};

typedef enum tfsp_screen_type	tfsp_screen_type;
enum tfsp_screen_type {
	TFSP_SCREENTYPE_UNKNOWN = 0,	/* (̤)       */
	TFSP_SCREENTYPE_FILE,			/* ե       */
	TFSP_SCREENTYPE_PERSONAL,		/* Ŀ       */
	TFSP_SCREENTYPE_UTILITY,		/* 桼ƥƥ */
};

/**
 * ҤȤĤΥեڡɽ¤
 */
struct tfsp_plugin_cpage {
	char *uri;			/* ̤URI */
	char *iconpath;		/* ɽΥѥ̾ */
	char *displayname;	/* ɽ̾(ܸ) */
	tfsp_screen_type screentype;

	int use_admin;	/* Ը¤ѤǤ뤫ɤ */
	int use_normal;	/* ̥桼¤ѤǤ뤫ɤ */
	int use_limited;	/* ¥桼¤ѤǤ뤫ɤ */
	int use_groupleader;	/* 롼ץ꡼¤ѤǤ뤫ɤ */
	char *displayname_en;	/* ɽ̾(Ѹ) */
};

/**
 * ץ饰ξ֤ɽ¤
 */
struct tfsp_plugin_state {
	int active;	/* ץ饰󤬥ƥ֤ɤ(1: ƥ / 0: 󥢥ƥ) */
};

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ǥ󥰤줿ץ饰ξ֤빽¤ [ Դ ]
 */
typedef struct tfsp_ctx_loader	tfsp_ctx_loader;

/*------------------------------------------------------------------------------
  Declare public functions
  ----------------------------------------------------------------------------*/
/**
 * ꤵ줿ǥ쥯ȥХѥ rootpath ʲˤץ饰饤֥
 * /ɤԤץ饰(ƥ).
 * rootpath NULL ξˤϡǥեȤΥեѥѤ.
 *
 * @param rootpath const char * ץ饰롼ȥѥ
 * @param loader tfsp_ctx_loader ** ץ饰󥳥ƥȤؤΥݥ
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_create(const char *rootpath, tfsp_ctx_loader **loader);

/**
 * ץ饰 loader 륤󥹥ȡ뤵줿ͭʥץ饰
 * ƥǥ󥰤ƻѲǽˤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @param plugin_err tfs_error_t ** ǥ󥰤ץ饰Υ顼.
 *   ͤNULLǤ⤳ˤͤ뤫⤷ޤ.
 *   ɬפǤХ˽ϤʤɤνԤʤäƤ.
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_loadAll(tfsp_ctx_loader *loader,
                                               tfs_error_t **plugin_err);

/**
 * ץ饰ǥ쥯ȥƥ󤷡ͭʥץ饰ɤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_reloadAll(tfsp_ctx_loader *loader);

/**
 * ץ饰󥳥ƥ loader Ǵ줿ץ饰򥢥ɤ
 * ѤǤʤ褦ˤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @param plugin_err tfs_error_t ** ɤץ饰Υ顼
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_unloadAll(tfsp_ctx_loader *loader,
                                                 tfs_error_t **plugin_err);

/**
 * ץ饰󥳥ƥ loader Ǵ줿ץ饰椫
 *  ptype̾ pname Υץ饰򥢥ɤƻѤǤʤ褦ˤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_unload(tfsp_ctx_loader *loader,
                                              tfsp_type_plugin ptype, const char *pname);

/**
 * ץ饰Child٥»ܤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @param plugin_err tfs_error_t ** ɤץ饰Υ顼
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_cinit(tfsp_ctx_loader *loader,
                                                 tfs_error_t **plugin_err);

/**
 * ץ饰Child٥뽪λ»ܤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @param plugin_err tfs_error_t ** ɤץ饰Υ顼
 */
TFS_DECLARE(void) tfsp_loader_cterminate(tfsp_ctx_loader *loader,
                                                 tfs_error_t **plugin_err);

/**
 * ƤΥץ饰򥢥ɤƥץ饰ƥȤ˴.
 * ܴؿƽФ塢loader ˿ƤϤʤޤ.
 *
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 */
TFS_DECLARE(void) tfsp_loader_destroy(tfsp_ctx_loader *loader);

/**
 * ץ饰󥳥ƥ loader Ǵ줿ץ饰椫
 *  ptype̾ pname Υץ饰.
 * pname NULLǤСptype Υץ饰󥤥󥿡ե⡢
 * ץ饰Ƭˤץ饰ޤ.
 * 
 * @param pool tfs_pool_t * ꥢ. NULL ʤloader ΤΤѤ
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @param ptype tfsp_type_plugin ץ饰
 * @param pname const char * ץ饰̾
 * @param pm ** const tfsp_plugin_module ץ饰⥸塼ؤΥݥ
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_lookupIf(tfs_pool_t *pool,
                                                tfsp_ctx_loader *loader,
                                                tfsp_type_plugin ptype, const char *pname,
                                                const tfsp_plugin_module **pm);

/**
 * ץ饰󥳥ƥ loader Ǵ줿ץ饰椫
 * ƥ֤ʥץ饰.
 * 
 * @param pool tfs_pool_t * ꥢ. NULL ʤloader ΤΤѤ
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @param plugins ** tfs_varray_t ץ饰⥸塼
 * @return tfs_error_t * 顼󥹥󥹤ؤΥݥ. Ȥädestroy
 */
TFS_DECLARE(tfs_error_t *) tfsp_loader_lookupAllIf(tfs_pool_t *pool,
                                                tfsp_ctx_loader *loader,
                                                tfs_varray_t **plugins);

/**
 * ץ饰 loader Υץ饰롼ȥǥ쥯ȥѥ.
 *
 * @param pool tfs_pool_t * ꥢ. NULL ʤloader ΤΤȤ
 * @param loader tfsp_ctx_loader * ץ饰ƥȤؤΥݥ
 * @return const char * ץ饰롼ȥǥ쥯ȥѥ
 */
TFS_DECLARE(const char *) tfsp_loader_get_rootpath(tfs_pool_t *pool,
                                                   tfsp_ctx_loader *loader);

/**
 * ץ饰󥰥Х륳ƥȤ.
 *
 * @param pm const tfsp_plugin_module *
 * @return const tfsp_ctx_global *
 */
TFS_DECLARE(const tfsp_ctx_global *) tfsp_pm_get_gctx(const tfsp_plugin_module *pm);

/**
 * ץ饰Child ٥륳ƥȤ.
 *
 * @param pm const tfsp_plugin_module *
 * @return const tfsp_ctx_child *
 */
TFS_DECLARE(const tfsp_ctx_child *) tfsp_pm_get_cctx(const tfsp_plugin_module *pm);

/**
 * ץ饰⥸塼pm ĥ󥿡ե.
 *
 * @param pm const tfsp_plugin_module *
 * @return void *
 */
TFS_DECLARE(void *) tfsp_pm_get_interface(const tfsp_plugin_module *pm);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFSP_LOADER_H */


