/**
 * $Id: tfs_errlog.h 1308 2006-02-21 16:25:47Z takehara $
 *
 * ѥ桼ƥƥ (顼֤ݻ)
 * [  ]
 *   ΥإåǤϡƤӽФʤɤ˥顼ȯξ֤Τ뤿ɬפ
 *   ƤޤŪ˥󥰤ʤޤǤϿƤޤ
 *   ϡ̤ΥǤäƤ
 */
#ifndef INCLUDE_TFS_ERRLOG_H
#define INCLUDE_TFS_ERRLOG_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"
#include "tfs_string.h"

#if HAVE_STDIO_H
#include <stdio.h>
#endif
#if HAVE_STDARG_H
#include <stdarg.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Define fixed values and macro
  ----------------------------------------------------------------------------*/
/**
 * 顼٥
 */
#ifdef HAVE_SYSLOG
#include <syslog.h>
#else	/* !HAVE_SYSLOG */
#define LOG_EMERG   0
#define LOG_ALERT   1
#define LOG_CRIT    2
#define LOG_ERR     3
#define LOG_WARNING 4
#define LOG_NOTICE  5
#define	LOG_INFO	6
#define	LOG_DEBUG	7
#endif	/* HAVE_SYSLOG */

/**
 * desc ʸݤѤޥ
 */
#define TFS_EDESC0(f)		(char *)__func__, __LINE__, f
#define TFS_EDESC1(f,a1)	(char *)__func__, __LINE__, f,a1
#define TFS_EDESC2(f,a1,a2)	(char *)__func__, __LINE__, f,a1,a2
#define TFS_EDESC3(f,a1,a2,a3)	(char *)__func__, __LINE__, f,a1,a2,a3
#define TFS_EDESC4(f,a1,a2,a3,a4)	(char *)__func__, __LINE__, f,a1,a2,a3,a4

/*------------------------------------------------------------------------------
  Define structure and enum
  ----------------------------------------------------------------------------*/
/**
 * 顼֤ݻ빽¤ [ Դ ]
 */
typedef struct tfs_error_t	tfs_error_t;

/*------------------------------------------------------------------------------
  Declare type of functions
  ----------------------------------------------------------------------------*/
/**
 * ؿ tfs_error_dumpall() Ϥ顼ؿ
 *
 * @param data void * 顼Ϥ벿餫ΥƥȤؤΥݥ
 * @param level int 顼٥
 * @param desc const char * 顼å
 */
typedef TFS_DECLARE(void) (*tfs_error_logger_t)(void *, int, const char *);

/*------------------------------------------------------------------------------
 * Declare public function
 *----------------------------------------------------------------------------*/
/**
 * 顼ådesc ꤷƥ顼󥤥󥹥󥹤.
 * funcname, lineno, desc åˤϡTFS_EDESC0 TFS_EDESC4 ޤǤ
 * ޥѤƲ.
 * ex)
 *   tfs_error_create(p, LOG_ERR, TFS_XXX, TFS_EDESC1("xxxx = %s", str));
 *
 * @param pool tfs_pool_t * ѥס
 * @param level int 顼٥
 * @param status int 顼ơ
 * @param funcname char * ؿ̾
 * @param lineno int ֹ
 * @param fmt const char * եޥåʸ(printfƱ)
 * @param ... Ĺʸ
 * @return tfs_error_t * 顼ݻ빽¤
 */
TFS_DECLARE(tfs_error_t *) tfs_error_create(tfs_pool_t *pool, int level, int status,
                                            char *funcname, int lineno, const char *fmt, ...);

/**
 * ꤵ줿顼Ͽꤵ줿顼prev ȴϢդ֤.
 * funcname, lineno, desc åˤϡTFS_EDESC0 TFS_EDESC4 ޤǤ
 * ޥѤƲ.
 * (note)
 * 	prev NULLǤв⤷ޤ.
 *
 * @param prev tfs_error_t * Υ顼
 * @param funcname char * ؿ̾
 * @param lineno int ֹ
 * @param level int 顼٥
 * @param status int 顼ơ
 * @param fmt const char * եޥåʸ(printfƱ)
 * @param ... Ĺʸ
 * @return tfs_error_t * 顼ݻ빽¤
 */
TFS_DECLARE(tfs_error_t *) tfs_error_push(tfs_error_t *prev, int level, int status,
                                          char *funcname, int lineno, const char *fmt, ...);

/**
 * ꤵ줿顼prev ˿顼new_err Ϣ뤷1ĤΥ顼ˤ.
 * ʤνä塢prev new_err פʤ˴Ʋ.
 * δؿˤä륨顼ϤȤ̤Υ󥹥󥹤Ȥʤޤ.
 *
 * @param pool tfs_pool_t * ꥢ
 * @param prev tfs_error_t * Υ顼
 * @param new_err tfs_error_t * Ϣ뤹륨顼
 * @return tfs_error_t * ϢΥ顼
 */
TFS_DECLARE(tfs_error_t *) tfs_error_append(tfs_pool_t *pool, tfs_error_t *prev,
                                            tfs_error_t *new_err);

/**
 * old 顼p ΥꥢȤäʣ.
 *
 * @param pool tfs_pool_t * ꥢ
 * @param old tfs_error_t * ʣ顼
 * @return tfs_error_t * ʣ줿顼
 */
TFS_DECLARE(tfs_error_t *) tfs_error_clone(tfs_pool_t *pool, tfs_error_t *old);

/**
 * err ݻƤΥ顼򥨥顼logger ȤäƽϤ.
 * ؿ뤵err ߤƤƤΥ顼ϥꥢޤ.
 *
 * @param err tfs_error_t * 顼
 * @param data void * logger Ϥ벿餫ΥǡؤΥݥ
 * @param logger tfs_error_logger_t 顼ؿؤΥݥ
 */
TFS_DECLARE(void) tfs_error_dumpall(tfs_error_t *err, void *data,
                                    tfs_error_logger_t logger);

/**
 * err ݻ륨顼ơ.
 * ʣĤΥ顼PushƤ硢ƬΥ顼ɤ֤ޤ.
 *
 * @param err tfs_error_t * 顼
 * @return tfs_status_t
 */
TFS_DECLARE(tfs_status_t) tfs_error_getstatus(tfs_error_t *err);

/**
 * stderr ˽Ϥ륨顼μ(tfs_error_logger_t μ)
 * 顼٥Ȥ̵ط˽Ϥޤ. data ϻѤޤ.
 * (note)
 *   tfs_error_logger_t μǤؿtfs_error_dumpallϤ
 *   Ϥ뤳ȤǽǤ
 *
 * @param data void * 顼Ϥ벿餫ΥƥȤؤΥݥ
 * @param level int 顼٥
 * @param desc const char * 顼å
 */
TFS_DECLARE(void) tfs_error_dump_stderr(void *data, int level, const char *desc);

/**
 * ǥХåѥ
 * (note)
 *   ŪˤϥǥХåѡɤƥե᡼ɽѥȤƻȤäƲ.
 *   funcname, lineno TFS_EDESC0 TFS_EDESC4 ȤäƲ.
 *   ()
 *     tfs_log_notice(TFS_EDESC1("aaaa = %s", xxx));
 *
 * @param funcname char * ؿ̾
 * @param lineno int ֹ
 * @param fmt const char * եޥåʸ(printfƱ)
 * @param ... Ĺʸ
 */
TFS_DECLARE(void) tfs_log_notice(char *funcname, int lineno, const char *fmt, ...);

/**
 * err 񤷤Ƥΰ˴.
 *
 * @param err tfs_error_t * 顼
 */
TFS_DECLARE(void) tfs_error_destroy(tfs_error_t *err);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_ERRLOG_H */

