/**
 * $Id: tfs_errno.h 3676 2013-04-10 04:46:06Z yone $
 *
 * ѥ桼ƥƥ (ơɡ顼)
 */
#ifndef INCLUDE_TFS_ERRNO_H
#define INCLUDE_TFS_ERRNO_H

#include "tfs.h"

#if HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Fixed values and Define Macro
  ----------------------------------------------------------------------------*/
/**
 * ХѿĴԤdefine ͤ
 */
#ifdef TFS_ERRMSG_GLOBAL_VALUE_DEFINE
#define TFS_ERRMSG_GLOBAL
#else
#define TFS_ERRMSG_GLOBAL extern
#endif  /* TFS_ERRMSG_GLOBAL_VALUE_DEFINE */

/*------------------------------------------------------------------------------
  Define structure and enum
  ----------------------------------------------------------------------------*/
/**
 * 顼ơɤɽ̾
 */
typedef tfs_uint32_t	tfs_status_t;

/**
 * 顼ɤȥ顼åδطݻ빽¤
 */
typedef struct tfs_err_elem	tfs_err_elem;
struct tfs_err_elem {
	tfs_status_t rv;
	const char *msg;
};

/*------------------------------------------------------------------------------
  Define error code
  ----------------------------------------------------------------------------*/
/**
 * 顼ɤΥХ
 */
#define TFS_SPEC_START_ERRNO	10000

/* 顼ɤȤΩƤޥ */
#define TFS_ERRNO(code)	(TFS_SPEC_START_ERRNO + (code))

/**
 * OSͭΥ顼ɤΥХ͡
 *
 * ͤOS顼ɤ­줿ͤȤƥ顼ɤޤ
 * (see errno.h)
 */
#define TFS_OS_START_ERRNO	30000

/* 顼ɤȤΩƤޥ */
#define TFS_OS_ERRNO(code)	(TFS_OS_START_ERRNO + (code))

/**
 * 顼ɰ
 */
enum {
	TFS_SUCCESS = 0,	/*  */
	TFS_FILE_EOF,		/* եEOFȯ */
	TFS_FILE_NOCONTENT,	/* 񤭹ߤޤɤ߹оݤΥեƤ̵ä */
	TFS_QUEUE_EMPTY,	/* Queue Ǥ¸ߤʤȤ򸡽Ф */

	TFS_ERR = TFS_SPEC_START_ERRNO + 1,	/* ͽʤͳǼԤ */
	TFS_EINVALID_PARAM,	/* ͤ */
	TFS_ENOPARAM,			/* ɬפ̵ͤä */
	TFS_ENOOBJ,		/* ɬפʥ֥ȤĤʤä */
	TFS_ENULLPOINTER,	/* NULLͤʤ˳ */
	TFS_EFILE_WRITE,	/* եν񤭹ߤ˼Ԥ */
	TFS_EREUSEXMLPARSER,	/* XML ѡ̤DOMΡɲϤѤ褦Ȥ */
	TFS_EPARSEXML,			/* XML Υѡ˼Ԥ */
};

/*------------------------------------------------------------------------------
  Define error message
  ----------------------------------------------------------------------------*/
TFS_ERRMSG_GLOBAL const tfs_err_elem tfs_err_map[]
#ifdef TFS_ERRMSG_GLOBAL_VALUE_DEFINE
= {
	{ TFS_SUCCESS,	"Success"	},
	{ TFS_FILE_EOF,	"Found file EOF status" },
	{ TFS_FILE_NOCONTENT,	"No content to read / write" },
	{ TFS_QUEUE_EMPTY,	"Queue is empty." },
	{ TFS_EERR,	"Unexptected Error"	},
	{ TFS_EINVALID_PARAM,	"Invalid parameters"	},
	{ TFS_ENOPARAM,	"Parameter was missing."	},
	{ TFS_ENOOBJ,	"Object was missing."	},
	{ TFS_ENULLPOINTER,	"NULL object found."	},
	{ TFS_EFILE_WRITE,	"Could not write data to file"	},
	{ TFS_EREUSEXMLPARSER,	"Could not reuse another DOM parser"	},
	{ TFS_EPARSEXML,	"Failed to parser XML text"	},
}
#endif	/* TFS_ERRMSG_GLOBAL_VALUE_DEFINE */
;

#ifdef TFS_ERRMSG_GLOBAL_VALUE_DEFINE
#define TFS_ERRMSG_MAP_LEN	sizeof(tfs_err_map)/sizeof(tfs_err_elem)
#else
#define TFS_ERRMSG_MAP_LEN 0
#endif	/* TFS_ERRMSG_GLOBAL_VALUE_DEFINE */

/*------------------------------------------------------------------------------
  Declare public functions
  ----------------------------------------------------------------------------*/
/**
 * 顼ɤ򥨥顼åѴ.
 *
 * @param rv tfs_status_t ơ
 * @param const char * const 顼å
 *		åȤ񤭴ƤϤʤޤ
 *		ʸƥʤΤCoreDumpޤ.
 */
/* TFS_DECLARE(const char * const) tfs_errcd2str(tfs_status_t rv); */


#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_ERRNO_H */

