/**
 * $Id: tfs_fileio.h 923 2005-12-04 10:17:39Z takehara $
 *
 * ѥ桼ƥƥ (fileio : եϢ)
 */
#ifndef INCLUDE_TFS_FILEIO_H
#define INCLUDE_TFS_FILEIO_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_common.h"
#include "tfs_string.h"

#if HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Define fixed values and macro
  ----------------------------------------------------------------------------*/
/**
 * üʥեopen ⡼
 */
/* OS Υǥեopen ⡼ (tfs_file_copy ˻Ѳǽ) */
#define TFS_FLMODE_OS_DEFAULT	(S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH)
/* src եΥѡߥåƱˤ뤿Υ⡼ (tfs_file_copy) */
#define TFS_FLMODE_SYNC_SRC	010000

/**
 * open Υե饰
 */
/* եopen  */
#define TFS_OFLG_NEWFILE	(O_CREAT|O_WRONLY|O_TRUNC|O_LARGEFILE)

/* ɤ߹Ѥopen  */
#define TFS_OFLG_READONLY	(O_RDONLY|O_LARGEFILE)

/*------------------------------------------------------------------------------
  Define structure and enum
  ----------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------
 * Declare public function
 *----------------------------------------------------------------------------*/
/**
 * ꤵ줿եǥץfd Υե뤫饵len ʬΥǡ
 * buf ɤ߹.
 *
 * @param fd int եǥץ
 * @param buf char * Хåե. ʤȤlen ΥХåեɬ.
 * @param *len tfs_ssize_t (byte). ɤ߹ߥ⤳ֵ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_file_read(int fd, char *buf, tfs_ssize_t *len);

/**
 * եѥpath Υե.
 * path Υե뤬openƤƤܴؿޤopenƤ
 * եclose ʤ¤ꥢǽȤʤޤ.
 *
 * @param path const char * оݥեΥեѥ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_file_remove(const char *path);

/**
 * եѥ src եեѥ dst Υѥ˰ư.
 * ư줿եΥѡߥåsrc Ʊˤʤޤ.
 * (note)
 *   ե̾ѹեѥѹǽǤ.
 *
 * @param src const char * ưեΥեѥ
 * @param dst const char * ưեΥեѥ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_file_move(const char *src, const char *dst);

/**
 * եѥ src եƤdst եѥ˥ԡ.
 *
 * @param src const char * ʣեΥեѥ
 * @param dst const char * ʣեΥեѥ
 * @param mode mode_t dst Υѡߥå(open ⡼)
 *             ǽͤˤĤƤϡstat.h 򻲾. ʤʲܥإå.
 *             TFS_FLMODE_OS_DEFAULT, TFS_FLMODE_SYNC_SRC
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_file_copy(const char *src, const char *dst, mode_t mode);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_FILEIO_H */

