/**
 * $Id: tfs_hashmap.h 1011 2005-12-25 16:27:53Z takehara $
 *
 * ѥ桼ƥƥ (HashMap : ϥåˤMap 󥿡եμ)
 */
#ifndef INCLUDE_TFS_HASHMAP_H
#define INCLUDE_TFS_HASHMAP_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ϥåޥåפɽƥȹ¤ [ Դ ]
 */
typedef struct tfs_hmap_t	tfs_hmap_t;

/**
 * ϥåޥå˻Ѥ륤ƥ졼 [ Դ ]
 */
typedef struct tfs_hmap_index_t	tfs_hmap_index_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ϥåޥåפ.
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢hmap 򥹥åɴ֤Ƕͭʤ¤
 *   åɥդȤʤޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param hmap tfs_hmap_t ** 줿ϥåޥåפؤΥݥ
 */
TFS_DECLARE(void) tfs_hmap_create(tfs_pool_t *pool, tfs_hmap_t **hmap);

/**
 * ʸ key ͤvalue δطϥåޥåhmap ˥ޥåפ.
 * (note)
 *   hmap Ǥvalue Υݥ󥿤ϿǤ. ԡϤޤ.
 *   ѹ뤳Ȥ򤱤ΤǤиƤӽФˤʣƤ
 *   ϤƲ.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 * @param key const char * ʸ(NOT NULL).
 *                         NULL Ͽޤ.
 * @param value const void * ͤؤΥݥ
 */
TFS_DECLARE(void) tfs_hmap_put(tfs_hmap_t *hmap, const char *key, const void *value);

/**
 * ʸ key ˥ޥåפ줿ͤϥåޥåhmap .
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 * @param key const char * ʸ(NOT NULL)
 * @return void * ޥåפ줿ͤؤΥݥ. ¸ߤʤNULLֵ.
 */
TFS_DECLARE(void *) tfs_hmap_get(tfs_hmap_t *hmap, const char *key);

/**
 * value ϥåޥåhmap ˥ޥåפƤ뤫ɤ.
 * (note)
 *   value ؤ֥ȤǤΤȽʤΤ
 *   δؿvalue Υݥ󥿤ñӤǤ.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 * @param value const char * ͤؤΥݥ
 * @return int ޤޤƤ뤫ɤ(1: ޤޤƤ / 0: ޤޤƤʤ)
 */
TFS_DECLARE(int) tfs_hmap_containsvalue(tfs_hmap_t *hmap, const void *value);

/**
 * ϥåޥåhmap 饭ʸ key Υޥåԥ󥰤.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 * @param key const char * ʸ(NOT NULL)
 * @return void * key ˥ޥåפƤ(Ϻ줿)֥ȤؤΥݥ
 */
TFS_DECLARE(void *) tfs_hmap_remove(tfs_hmap_t *hmap, const char *key);

/**
 * ϥåޥåhmap ˥ޥåפ줿ޥåԥ󥰤ο֤.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 * @return tfs_int32_t 
 */
TFS_DECLARE(tfs_int32_t) tfs_hmap_size(tfs_hmap_t *hmap);

/**
 * ϥåޥåhmap Υƥ졼ֵѤ.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 * @return tfs_hmap_index_t * ƥ졼ؤΥݥ
 */
TFS_DECLARE(tfs_hmap_index_t *) tfs_hmap_first(tfs_hmap_t *hmap);

/**
 * ƥ졼iterator Ǥؤ褦˰ư.
 *
 * @param iterator tfs_hmap_index_t * ƥ졼
 * @return tfs_hmap_index_t * Υƥ졼ؤΥݥ. NULLǽü򼨤
 */
TFS_DECLARE(tfs_hmap_index_t *) tfs_hmap_next(tfs_hmap_index_t *iterator);

/**
 * ƥ졼iterator ϥåޥåפ˥ޥåפ줿ͤȤ߹碌
 * .
 * (note)
 *   key  value Ȥ񤭴hmap ͤѤä
 *   ޤޤ. äkey ˴ؤƤϽ񤭴 tfs_hmap_get() 
 *   ưʤʤޤ.
 *   񤭴ǤϤʤtfs_hmap_put() ľƤ.
 *
 * @param iterator tfs_hmap_index_t * ƥ졼
 * @param key const char ** ޥåפ줿ʸؤΥݥ
 * @param value const void ** key ȴϢդ줿ͤؤΥݥ
 */
TFS_DECLARE(void) tfs_hmap_getvalue(tfs_hmap_index_t *iterator,
                                    const char **key, const void **value);

/**
 * ϥåޥåhmap Ǥ򥯥ꥢ.(ޥåפβ)
 *
 * ϥåޥå˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 */
TFS_DECLARE(void) tfs_hmap_clear(tfs_hmap_t *hmap);

/**
 * hmap ɽϥåޥåפ˴.
 *
 * ϥåޥå˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param hmap tfs_hmap_t * ϥåޥåפؤΥݥ
 */
TFS_DECLARE(void) tfs_hmap_destroy(tfs_hmap_t *hmap);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_HASHMAP_H */

