/**
 * $Id: tfs_hashset.h 1023 2005-12-31 12:42:50Z takehara $
 *
 * ѥ桼ƥƥ (HashSet : ϥåˤSet 󥿡եμ)
 */
#ifndef INCLUDE_TFS_HASHSET_H
#define INCLUDE_TFS_HASHSET_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ϥå奻åȤɽƥȹ¤ [ Դ ]
 */
typedef struct tfs_hset_t	tfs_hset_t;

/**
 * ϥå奻å˻Ѥ륤ƥ졼 [ Դ ]
 */
typedef struct tfs_hset_index_t	tfs_hset_index_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ϥå奻åȤ
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢hset 򥹥åɴ֤Ƕͭʤ¤
 *   åɥդȤʤޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param hset tfs_hset_t ** 줿ϥå奻åȤؤΥݥ
 */
TFS_DECLARE(void) tfs_hset_create(tfs_pool_t *pool, tfs_hset_t **hset);

/**
 * element ϥå奻åhset ˤʤä硢åȤɲä.
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 * @param element const char * ʸؤΥݥ
 * @return int åȤꤵ줿ǤݻƤʤä1/ʳ0
 */
TFS_DECLARE(int) tfs_hset_add(tfs_hset_t *hset, const char *element);

/**
 * ʸ element ϥå奻åhset ˴ޤޤƤ뤫ɤ.
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 * @param element const char * ʸؤΥݥ
 * @return int äƤ(1) / äƤʤ(0)
 */
TFS_DECLARE(int) tfs_hset_contains(tfs_hset_t *hset, const char *element);

/**
 * ꤵ줿ʸelement ϥå奻åhset .
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 * @param element const char * оݤʸؤΥݥ
 * @return int åȤꤵ줿ǤݻƤ1/ʳ0
 */
TFS_DECLARE(int) tfs_hset_remove(tfs_hset_t *hset, const char *element);

/**
 * ϥå奻åhset ݻǿ֤.
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 * @return tfs_int32_t ǿ
 */
TFS_DECLARE(tfs_int32_t) tfs_hset_size(tfs_hset_t *hset);

/**
 * ϥå奻åhset Υƥ졼ֵѤ.
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 * @return tfs_hset_index_t * ƥ졼ؤΥݥ
 */
TFS_DECLARE(tfs_hset_index_t *) tfs_hset_first(tfs_hset_t *hset);

/**
 * ƥ졼iterator Ǥؤ褦˰ư.
 *
 * @param iterator tfs_hset_index_t * ƥ졼
 * @return tfs_hset_index_t * Υƥ졼. NULLǽü򼨤.
 */
TFS_DECLARE(tfs_hset_index_t *) tfs_hset_next(tfs_hset_index_t *iterator);

/**
 * ƥ졼iterator ϥå奻åȤ˥ޥåפ줿ʸ.
 * (note)
 *   ֥element ȤϽ񤭴ʤǲ. 
 *   ֤Τʤtfs_hset_remove() ǾäƤ
 *   tfs_hset_add() ɲäƤ.
 *
 * @param iterator tfs_hset_index_t * ƥ졼
 * @param element const char ** ǤؤΥݥ
 */
TFS_DECLARE(void) tfs_hset_getvalue(tfs_hset_index_t *iterator, const char **element);

/**
 * ϥå奻åhset Ǥ򥯥ꥢ.
 *
 * ϥå奻å˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 */
TFS_DECLARE(void) tfs_hset_clear(tfs_hset_t *hset);

/**
 * hset ϥå奻åȤ˴.
 *
 * ϥå奻å˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param hset tfs_hset_t * ϥå奻åȤؤΥݥ
 */
TFS_DECLARE(void) tfs_hset_destroy(tfs_hset_t *hset);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_HASHSET_H */

