/**
 * $Id: tfs_linkedlist.h 1017 2005-12-26 23:51:56Z takehara $
 *
 * ѥ桼ƥƥ (LinkedList : Ĺꥹ)
 */
#ifndef INCLUDE_TFS_LINKEDLIST_H
#define INCLUDE_TFS_LINKEDLIST_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ĹꥹȤɽƥȹ¤ [ Դ ]
 */
typedef struct tfs_linkedlist_t	tfs_linkedlist_t;

/**
 * ĹꥹȤΥƥ졼ɽ¤ [ Դ ]
 */
typedef struct tfs_linkedlist_index_t	tfs_linkedlist_index_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ĹꥹȤ.
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢llist 򥹥åɴ֤Ƕͭʤ¤
 *   åɥդȤʤޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param llist tfs_linkedlist_t ** ĹꥹȤؤΥݥ
 */
TFS_DECLARE(void) tfs_linkedlist_create(tfs_pool_t *pool, tfs_linkedlist_t **llist);

/**
 * ꤵ줿element Ĺꥹllist ɲä.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 * @param element void * ɲä륪֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_linkedlist_add(tfs_linkedlist_t *llist, void *element);

/**
 * Ĺꥹllist ΰindex ˤǤelement ֤.
 * index ϰϳǤв⤷ޤ.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 * @param index tfs_int32_t ɲð
 * @param element void * ɲä륪֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_linkedlist_set(tfs_linkedlist_t *llist,
                                     tfs_int32_t index, void *element);

/**
 * Ĺꥹllist ΰindex ˤ륪֥Ȥ֤.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 * @param index tfs_int32_t 
 */
TFS_DECLARE(void *) tfs_linkedlist_remove(tfs_linkedlist_t *llist, tfs_int32_t index);

/**
 * llist ĹꥹȤpool Υΰ˥ԡ.
 * (note)
 *   Ĺꥹ ˳Ǽ줿ͤϥԡޤ󡣥ݥ󥿤Ѥޤ.
 *   ʪCloneǤ.
 *
 * @param pool tfs_pool_t *
 * @param llist tfs_linkedlist_t * ԡ
 * @return tfs_linkedlist_t * ʣĹꥹȤؤΥݥ
 */
TFS_DECLARE(tfs_linkedlist_t *) tfs_linkedlist_clone(tfs_pool_t *pool, tfs_linkedlist_t *llist);

/**
 * Ĺꥹllist ǿ.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 */
TFS_DECLARE(tfs_int32_t) tfs_linkedlist_size(tfs_linkedlist_t *llist);

/**
 * Ĺꥹllist ΰindex ˤ륪֥Ȥ.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 * @param index tfs_int32_t 
 * @return void * index ˳ǼƤ֥ȤؤΥݥ
 */
TFS_DECLARE(void *) tfs_linkedlist_get(tfs_linkedlist_t *llist, tfs_int32_t index);

/**
 * Ĺꥹllist Υƥ졼ֵѤ.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 * @return tfs_linkedlist_index_t * ƥ졼ؤΥݥ
 */
TFS_DECLARE(tfs_linkedlist_index_t *) tfs_linkedlist_first(tfs_linkedlist_t *llist);

/**
 * ƥ졼iterator Ǥؤ褦˰ư.
 *
 * @param iterator tfs_linkedlist_index_t * ƥ졼
 * @return tfs_linkedlist_index_t * Υƥ졼ؤΥݥ. NULLǽü򼨤
 */
TFS_DECLARE(tfs_linkedlist_index_t *) tfs_linkedlist_next(tfs_linkedlist_index_t *iterator);

/**
 * ƥ졼ͤ.
 *
 * @param iterator tfs_linkedlist_index_t * ƥ졼
 * @return void * j
 */
TFS_DECLARE(void *) tfs_linkedlist_getvalue(tfs_linkedlist_index_t *iterator);

/**
 * Ĺꥹllist Ǥƥꥢ.
 *
 * Ĺꥹ˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 */
TFS_DECLARE(void) tfs_linkedlist_clear(tfs_linkedlist_t *llist);

/**
 * Ĺꥹllist ȤƤΰ˴.
 *
 * ѥꥹ˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param llist tfs_linkedlist_t * ĹꥹȤؤΥݥ
 */
TFS_DECLARE(void) tfs_linkedlist_destroy(tfs_linkedlist_t *llist);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_LINKEDLIST_H */

