/**
 * $Id: tfs_mcache.h 1011 2005-12-25 16:27:53Z takehara $
 *
 * ѥ桼ƥƥ (Allocated Memory Cache : ȺѤߥΰΥå)
 * (note)
 *   ѲǽʥꥭåμǤϤޤ.
 *   ñˡmalloc ˤäƥҡפ˳Ƥ줿֥ȤؤΥݥ󥿤
 *   ʣƤפˤʤäfree뤿ѤƲ.
 *   ʾεǽͿƤޤ.
 */
#ifndef INCLUDE_TFS_MCACHE_H
#define INCLUDE_TFS_MCACHE_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ȺѤߥΰݻ빽¤ [ Դ ]
 */
typedef struct tfs_mcache_t	tfs_mcache_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ȺѤߥꥭå.
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param size tfs_int32_t åĿ (-1 줿鼫ưƤޤ)
 * @param mcache tfs_mcache_t ** ȺѤߥꥭåؤΥݥ
 */
TFS_DECLARE(void) tfs_mcache_create(tfs_pool_t *pool,
                                    tfs_int32_t size, tfs_mcache_t **mcache);

/**
 * Ȥ֥ȤؤΥݥ󥿤mcache Ͽ.
 * (note)
 *   obj ΰ褬Ƥ硢tfs_mcache_cleanup 򵯤ޤ.
 *
 * @param mcache tfs_mcache_t * ȺѤߥꥭåؤΥݥ
 * @param obj void * ǥȤ줿֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_mcache_add(tfs_mcache_t *mcache, void *obj);

/**
 * Ȥ֥ȤؤΥݥobj Ȱפݥ󥿤
 * mcache õ.
 * פ륪֥Ȥʤв⤷ޤ.
 *
 * @param mcache tfs_mcache_t * ȺѤߥꥭåؤΥݥ
 * @param obj void * ǥȤ줿֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_mcache_remove(tfs_mcache_t *mcache, void *obj);

/**
 * ȺѤߥꥭåϿƤ륪֥Ȥο֤.
 *
 * @param mcache tfs_mcache_t * ȺѤߥꥭåؤΥݥ
 * @return tfs_int32_t å夵줿֥ȿ
 */
TFS_DECLARE(tfs_int32_t) tfs_mcache_size(tfs_mcache_t *mcache);

/**
 * ȺѤߥꥭåϿ줿֥Ȥ
 * ҡΰƳ(free).
 *
 * @param mcache tfs_mcache_t * ȺѤߥꥭåؤΥݥ
 */
TFS_DECLARE(void) tfs_mcache_cleanup(tfs_mcache_t *mcache);

/**
 * ȺѤߥꥭå˴.
 * ꡼󥢥åפƤʤ֥ȤСΰγԤäƤ
 * mcache ˴ޤ.
 *
 * @param mcache tfs_mcache_t * ȺѤߥꥭåؤΥݥ
 */
TFS_DECLARE(void) tfs_mcache_destroy(tfs_mcache_t *mcache);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_MCACHE_H */

