/**
 * $Id: tfs_pools.h 987 2005-12-25 04:57:15Z takehara $
 *
 * ѥ桼ƥƥ (Memory Allocator : ѥ桼ƥƥѥꥢ)
 *
 * (note1)
 *   ꥢɬפʾؤɤ (1) malloc ǳ
 *   (2) Фƽ񤭹 (3) פˤʤäΰfree
 *   ȤϢήˤʤޤ. ΤȤ(2) ϳƽͭѲϺǤ
 *   (1)Υݥ󥿤ФƤơ(3) λˤΥݥ󥿤free뤳ȤưפǤ.
 *   GC Τ褦ѵ񤷤Ǥ٤λٱǤݥ󥿤ɤ
 *   å夷ƤȤѤ路ڸ졢ʤڤˤʤǤ礦.
 *   Memory Allocator Ϥ¸뤿εäƤޤ.
 *   apr_pool_t λۤޤͤƤޤ.
 *
 * (note2)
 *   ꥢϥꥢ줿ΰѤ뤫⤷ޤ.
 *   ǤΤǡݥͤ򥭥å夷Ƥƥ֥ȤƱȽǤ
 *   ץդǤ. ꥢ줿ͤˤʤФǤʤ̤
 *   ֥ȤؤΥݥ󥿤ȤƺѤ뤫⤷ʤǤ.
 */
#ifndef INCLUDE_TFS_POOLS_H
#define INCLUDE_TFS_POOLS_H

/**
 * (note)
 *   tfs_pools.h tfs.hޤtfs_errno.h ʳinclude ƤϤʤޤ.
 *   Υ롼ˤȡإåΰ¸طʤޤ.
 */
#include "tfs.h"
#include "tfs_errno.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ꥢɽ¤ [ Դ ]
 */
typedef struct tfs_pool_t	tfs_pool_t;

/*------------------------------------------------------------------------------
  Declare type of functions
  ----------------------------------------------------------------------------*/
/**
 * ꡼󥢥åץϥɥȤǽʴؿ
 *
 * @param void * ꡼󥢥åץϥɥ餬ǤդΥ֥ȤؤΥݥ
 */
typedef TFS_DECLARE(void) (*tfs_pool_cleanup_t)(void *);

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ꥢ.
 * (note)
 *   ʹߡtfs_pool_release() tfs_pool_destroy() ʤ¤ꡢꥢ
 *   Ƥ줿ΰOSֵѤʤʤޤ.
 *   ޤΥꥢƤ줿ϸƤӽФ
 *   free() ƤϤʤޤ. μ¤CoreDumpޤ.
 *
 * @param pool tfs_pool_t ** ꥢؤΥݥ
 */
TFS_DECLARE(void) tfs_pool_create(tfs_pool_t **pool);

/**
 * ꥢˤäƳƤƤݥ󥿤
 * ꥻåȤƺѲǽʾ֤ˤ.
 *
 * [ tfs_pool_release() Ȥΰ㤤 ]
 *   OS˥֤ɤǤ.malloc() ؿϤʤꥳȤι⤤
 *   ٤ʥ르ꥺѤƤΤǡtfs_pool_clear() 
 *   Ѥ®ˤʤǤ礦.
 *
 * (note)
 *   Ǥϡtfs_pool_release() ƱưˤʤäƤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 */
TFS_DECLARE(void) tfs_pool_clear(tfs_pool_t *pool);

/**
 * ꥢˤäƳƤ줿ΰOS֤.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 */
TFS_DECLARE(void) tfs_pool_release(tfs_pool_t *pool);

/**
 * ꥢˤäƳƤ줿γȼȤ˴.
 * (note)
 *   δؿƽФ塢pool ˿ƤϤʤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 */
TFS_DECLARE(void) tfs_pool_destroy(tfs_pool_t *pool);

/**
 * ꥢpool 饵size ХȤΥΰ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param size tfs_size_t Ƥꥵ
 */
TFS_DECLARE(void *) tfs_palloc(tfs_pool_t *pool, tfs_size_t size);

/**
 * ꥢpool 饵size ХȤΥΰ
 * ΰ0ꥢ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param size tfs_size_t Ƥꥵ
 */
TFS_DECLARE(void *) tfs_pcalloc(tfs_pool_t *pool, tfs_size_t size);

/**
 * pool ꥢꥢޤ˴ľ˥뤵
 * ꡼󥢥åץϥɥؿϿ.
 * (note)
 *   ꡼󥢥åץϥɥϡFILO ǥ뤵ޤ.(Ͽεս˥)
 *   ޤƱdata Ʊ꡼󥢥åץϥɥؿϿ
 *   Ū˥󥻥뤷ޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param data const void * ꡼󥢥åץϥɥϤؤΥݥ
 * @param cleanup_fn tfs_pool_cleanup_t ꡼󥢥åץϥɥؿؤΥݥ
 */
TFS_DECLARE(void) tfs_pool_cleanup_register(tfs_pool_t *pool, const void *data,
                                            tfs_pool_cleanup_t cleanup_fn);

/**
 * data cleanup_f ꡼󥢥åץϥɥϿ򥭥󥻥뤷
 * ƤӽФʤ褦ˤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param data const void * ꡼󥢥åץϥɥϤؤΥݥ
 * @param cleanup_fn tfs_pool_cleanup_t ꡼󥢥åץϥɥؿؤΥݥ
 */
TFS_DECLARE(void) tfs_pool_cleanup_kill(tfs_pool_t *pool, const void *data,
                                        tfs_pool_cleanup_t cleanup_fn);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_POOLS_H */

