/**
 * $Id: tfs_queue.h 1017 2005-12-26 23:51:56Z takehara $
 *
 * ѥ桼ƥƥ (Queue : FIFO Queue)
 */
#ifndef INCLUDE_TFS_QUEUE_H
#define INCLUDE_TFS_QUEUE_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * Queueɽƥȹ¤ [ Դ ]
 */
typedef struct tfs_queue_t	tfs_queue_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * Queue .
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢hmap 򥹥åɴ֤Ƕͭʤ¤
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param queue tfs_queue_t ** 줿FIFO QueueؤΥݥ
 */
TFS_DECLARE(void) tfs_queue_create(tfs_pool_t *pool, tfs_queue_t **queue);

/**
 * Queue value . (PUSH)
 * (note)
 *   value ϥԡݥ󥿤ΤޤQueue˳Ǽޤ.
 *   ƤӽФvalue ΰƤޤQueue˳Ǽ줿ͤͤˤʤޤ.
 *
 * @param queue tfs_queue_t * QueueؤΥݥ
 * @param value void * QueueǡؤΥݥ
 *                     NULL ݥ󥿤ϳǼǤޤ.
 * 	TFS_SUCCESS : 
 * 	TFS_ENOPARAM : queue NULLä
 * 	TFS_ENULLPOINTER : NULL 褦Ȥ
 */
TFS_DECLARE(tfs_status_t) tfs_queue_push(tfs_queue_t *queue, void *value);

/**
 * Queue ͤФ. (POP)
 * Ф줿ͤQueueޤ.
 *
 * @param queue tfs_queue_t * QueueؤΥݥ
 * @param value void ** Queue Ф줿ǡΰؤΥݥ
 * @param tfs_status_t POPơ
 * 	TFS_SUCCESS     : ͤμ.
 * 	TFS_QUEUE_EMPTY : ͤäƤʤä (*value NULLˤʤޤ)
 */
TFS_DECLARE(tfs_status_t) tfs_queue_pop(tfs_queue_t *queue, void **value);

/**
 * Queue ͤФ. (POP)
 * Ф줿ͤQueue"ޤ".(tfs_queue_pop Ȥΰ㤤)
 *
 * @param queue tfs_queue_t * QueueؤΥݥ
 * @param value void ** Queue Ф줿ǡΰؤΥݥ
 * @param tfs_status_t POPơ
 * 	TFS_SUCCESS     : ͤμ.
 * 	TFS_QUEUE_EMPTY : ͤäƤʤä (*value NULLˤʤޤ)
 */
TFS_DECLARE(tfs_status_t) tfs_queue_peek(tfs_queue_t *queue, void **value);

/**
 * queue Queuepool Υΰ˥ԡ.
 * (note)
 *   Queue ˳Ǽ줿ͤϥԡޤ󡣥ݥ󥿤Ѥޤ.
 *   ʪCloneǤ.
 *
 * @param pool tfs_pool_t *
 * @param queue tfs_queue_t * ԡ
 * @return tfs_queue_t * ʣQueueؤΥݥ
 */
TFS_DECLARE(tfs_queue_t *) tfs_queue_clone(tfs_pool_t *pool, tfs_queue_t *queue);

/**
 * Queue ˳Ǽ줿Ǥ.
 *
 * @param queue tfs_queue_t * QueueؤΥݥ
 */
TFS_DECLARE(tfs_int32_t) tfs_queue_size(tfs_queue_t *queue);

/**
 * queue QueueǤƥꥢ.
 *
 * @param queue tfs_queue_t * QueueؤΥݥ
 */
TFS_DECLARE(void) tfs_queue_clear(tfs_queue_t *queue);

/**
 * queue Queue˴.
 *
 * @param queue tfs_queue_t * QueueؤΥݥ
 */
TFS_DECLARE(void) tfs_queue_destroy(tfs_queue_t *queue);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_QUEUE_H */

