/**
 * $Id: tfs_sbuf.h 1011 2005-12-25 16:27:53Z takehara $
 *
 * ѥ桼ƥƥ (StringBuffer : ĹʸХåե)
 */
#ifndef INCLUDE_TFS_SBUF_H
#define INCLUDE_TFS_SBUF_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * ĹʸХåեɽƥȹ¤ [ Դ ]
 */
typedef struct tfs_sbuf_t	tfs_sbuf_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ĹʸХåե.
 * ꤵ줿size ХȤʸǼǽʸХåեsbuf 
 * ֵѤ.
 * ݤʸХåեˤʸüʸ'\0' Ǽΰ褬ưŪ
 * ɲäޤ(Ĥޤ size + 1ХʬݤȤ)
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * Хåե­ʤʤäȤʬ(delta) ϰʲΤ褦˷ꤷޤ
 * (1) size/2  ǥեå ⾮Ȥˤ
 * 	ǥեåѤ
 * (2) size/2  ǥեå礭ˤ
 * 	size/2 Ѥ
 * (note)
 * 	size λˤϡǥե(> 0) ΥХåեݤޤ
 *
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢sbuf 򥹥åɴ֤Ƕͭʤ¤
 *   åɥդȤʤޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param size tfs_size_t ʸХåեΥ(byte)
 * @param sbuf tfs_sbuf_t ** ʸХåե
 */
TFS_DECLARE(void) tfs_sbuf_create(tfs_pool_t *pool, tfs_size_t size, tfs_sbuf_t **sbuf);

/**
 * ꤵ줿str ʸĹͤȤƤʸХåեsbuf 
 * ֵѤ롣
 * ݤʸХåե strlen(str) + 1 ХȤȤʤޤ
 * Ĥޤꡢstr ʸƤݻǤΥХåեݤޤ
 * ʤstr NULLξˤϥǥեȥΥХåեݤޤ
 *
 * (note)
 * pool ꤵ줿硢pool ꥢȤʤޤ
 * δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 * ưŪ˴ޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param str const char * ǽ˥åȤʸ
 * @param sbuf tfs_sbuf_t ** ʸХåե
 */
TFS_DECLARE(void) tfs_sbuf_createbyStr(tfs_pool_t *pool, const char *str, tfs_sbuf_t **sbuf);

/**
 * ʸХåեsbuf ꤵ줿ʸХåեθߤΥ(byte)롣
 * (note)
 * 	ǼƤʸĹǤϤޤ󡣥ХåեΤĹǤ
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @return tfs_size_t ʸХåեθߤĹ(byte)
 */
TFS_DECLARE(tfs_size_t) tfs_sbuf_getcapacity(tfs_sbuf_t *sbuf);

/**
 * ʸХåեsbuf ɲä줿ʸĹ(byte)롣
 * (note)
 * 	tfs_sbuf_getcapacity ͤȤϰۤʤ뤳Ȥޤ
 * 	ޤ'\0'ʬϥȤޤ(strlenƱǤ)
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @return tfs_size_t ɲä줿ʸĹ(byte)
 */
TFS_DECLARE(tfs_size_t) tfs_sbuf_getlength(tfs_sbuf_t *sbuf);

/**
 * ʸХåեsbuf ˺Ǹɲä줿ʸθˤstr ʸ
 * ɲä롣
 * str NULLλˤϲ⤷ޤ
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @param str const char * ɲäʸ
 */
TFS_DECLARE(void) tfs_sbuf_append(tfs_sbuf_t *sbuf, const char *str);

/**
 * ʸХåեsbuf κǸɲä줿ʸθˤstr ʸ
 * len ХȤɲä롣str NULLlen 0 λˤϲ⤷ޤ
 * (note) tfs_sbuf_append Ȥΰ㤤
 * 	δؿϡʸĹƤӽФ¦ǴȽƤ(㤨
 * 	ͤʤ)tfs_sbuf_appendstrlen׻ʤʬ
 * 	®ˤʤޤ(ϤǤ)
 * 	ʳνtfs_sbuf_append ƱǤ
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @param str const char * ɲäʸ
 */
TFS_DECLARE(void) tfs_sbuf_appendByte(tfs_sbuf_t *sbuf,
                                      tfs_size_t len, const char *str);

/**
 * ʸХåեsbuf κǸɲä줿ʸθˤch ʸɲä.
 * ch '\0' ɲäޤ.
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @param str const char * ɲäʸ
 */
TFS_DECLARE(void) tfs_sbuf_appendChar(tfs_sbuf_t *sbuf, char ch);

/**
 * ʸХåեsbuf start ǥå֤ʸstr ɲä롣
 * start֤ˤäʸstrlen(str) ʬ˰ưޤ
 * ()
 * 	sbuf: "01234abcd"λ
 * 	tfs_sbuf_insert(sbuf, 3, "xxxxx") -> "012xxxxx34abcd"
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @param start tfs_size_t ǥå
 * @param str const char * ɲäʸ
 * @return tfs_status_t ơ
 * 	tfs_sbuf_getlength() η̤start礭Ȥޤ
 * 	startͤλˤϰ۾ｪλޤ
 */
TFS_DECLARE(tfs_status_t) tfs_sbuf_insert(tfs_sbuf_t *sbuf,
                                          tfs_size_t start, const char *str);

/**
 * ʸХåեsbuf start ǥå֤饤ǥå
 * (end - 1) ޤǤstr ʸִ
 * str  ִĹĹˤڤäޤ
 * ޤstr  ִĹûˤϡstrlen(str) ޤǤ򥳥ԡޤ
 * end ХåեĹ礭ˤϥХåեưĥޤ
 * ()
 * 	sbuf: "01234abcd"λ
 * 	tfs_sbuf_replace(sbuf, 2, 5, "xxxxx") -> "01xxxabcd"
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @param start tfs_size_t ֤Ƭǥå
 * @param end tfs_size_t   ֤ü֤ΥХȿ
 * @param str const char * ֤ʸ
 * @return tfs_status_t ơ
 * 	tfs_sbuf_getlength() η̤start礭Ȥޤ
 * 	startͤλˤϰ۾ｪλޤ
 */
TFS_DECLARE(tfs_status_t) tfs_sbuf_replace(tfs_sbuf_t *sbuf, tfs_size_t start,
                                           tfs_size_t end, const char *str);

/**
 * ʸХåեsbuf ǼƤƤʸ롣
 * (note)
 * 	ʸϡΰ˥ԡޤ
 * 	ХåեäƤݥ󥿤ֵѤǤ
 * 	Τᡢtfs_sbuf_toString Ǽʸ򥳥ԡ
 * 	tfs_sbuf_clear »ܤȡʸ϶ˤʤäƤޤޤ
 * 	tfs_sbuf_clear ȤȤ߹碌ǤդɬפǤ
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 * @return char * ʸ
 */
TFS_DECLARE(char *) tfs_sbuf_toString(tfs_sbuf_t *sbuf);

/**
 * ʸХåեsbuf ˳Ǽ줿ʸƾõ롣
 * ݤ줿Хåեΰϥꥢޤ
 * (note)
 * 	tfs_sbuf_toString ؿȤȤ߹碌ǤդɬפǤ
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 */
TFS_DECLARE(void) tfs_sbuf_clear(tfs_sbuf_t *sbuf);

/**
 * sbuf ˥ȤƤΰ.
 * δؿƽФ塢sbuf ˿äƤϤʤޤ.
 *
 * @param sbuf tfs_sbuf_t * ʸХåեؤΥݥ
 */
TFS_DECLARE(void) tfs_sbuf_destroy(tfs_sbuf_t *sbuf);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_SBUF_H */

