/**
 * $Id: tfs_string.h 1387 2006-03-06 02:17:52Z takehara $
 *
 * ѥ桼ƥƥ (string : ʸϢ)
 */
#ifndef INCLUDE_TFS_STRING_H
#define INCLUDE_TFS_STRING_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#if HAVE_STDARG_H
#include <stdarg.h>
#endif
#if HAVE_CTYPE_H
#include <ctype.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Define fixed values and macro
  ----------------------------------------------------------------------------*/
#ifndef IS_EMPTY
/**
 * NULL ޤ϶ʸǤ뤫ɤȽꤹޥ
 *
 * @param s char * / const char * ʸؤΥݥ
 */
#define IS_EMPTY(s) (s == NULL || *(s) == '\0')
#endif	/* IS_EMPTY */

#ifndef IS_FILLED
/**
 * ʸs ŶƤ(NULLǤϤʤ && ǤϤʤ)ȤȽꤹޥ
 * (note)
 * 	!IS_EMPTY(s) Ʊ̣ˤʤޤ
 * 	ɾȽ䤹ä̾ˤƤǤ
 *
 * @param s char * / const char * ʸؤΥݥ
 */
#define IS_FILLED(s) (s != NULL && *(s) != '\0')
#endif	/* IS_FILLED */

/*------------------------------------------------------------------------------
  Declare structure/enum
  ----------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------
  Define structure/enum
  ----------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------
  Declare public functions 1 (ꥢʸ桼ƥƥ)
  ----------------------------------------------------------------------------*/
/**
 * s ʸΥΰpool˳ݤƤ򥳥ԡ. (ꥢ)
 *
 * ʣ줿ǡɬ̥뽪ü(\0)Ȥʤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param s const char * ʸ
 * @return char * ʣ줿ʸؤΥݥ
 *                ΰϥꥢƤޤ. free() ػ.
 */
TFS_DECLARE(char *) tfs_pstrdup(tfs_pool_t *pool, const char *s);

/**
 * s ʸΤnʸʬʣƥ̥뽪üֵ. (ꥢ)
 * s Ĺn 礭ˤϡtfs_pstrdup() ƱưȤʤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param s const char * ʸ
 * @param n tfs_size_t ʣʸθĿ(̥뽪üϥȤޤ)
 * @return char * ʣʸؤΥݥ
 *                n == 0s == NULL ξˤʣޤ. free() ػ.
 */
TFS_DECLARE(char *) tfs_pstrndup(tfs_pool_t *pool, const char *s, tfs_size_t n);

/**
 * ꤵ줿ʣʸϢ뤹. (ꥢ)
 * (note)
 *   Ϣνüˤɬ NULL ꤷƲ.
 *   ()
 *       char *s = tfs_pstrcat("abc", "123", "xxxx", NULL);
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param s0 const char * Ƭʸ. 줬NULLϢϤޤ.
 * @param ... (Ĺѥ᡼) ɬʸǤʤФʤޤ.
 *                               Ǥʤˤ˽ޤ.
 * @return char * Ϣ뤷ʸؤΥݥ
 */
TFS_DECLARE(char *) tfs_pstrcat(tfs_pool_t *pool, const char *s0, ...);

/**
 * ꤵ줿ʣʸnʸʬϢ뤹.(ꥢ)
 *
 * ϢĹ n 礭ˤϡtfs_pstrcat() ƱưȤʤޤ.
 * ϢĹ n ˤϡƬnʸʬʣޤ.
 * ֵѤǡνüɬNULLüȤʤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param n tfs_size_t Ϣʸʸ
 * @param s0 const char * Ƭʸ. 줬NULLϢϤޤ.
 * @return char * Ϣ뤷ʸؤΥݥ
 */
TFS_DECLARE(char *) tfs_pstrncat(tfs_pool_t *pool, tfs_size_t n, const char *s0, ...);

/**
 * printf-style ν񼰻ʸѤǤʸؿ.
 * ꤵ줿եޥåȤʸֵѤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param fmt const char * 񼰻ʸ
 * @param ... Ĺʸ 
 * @return char * ȤΩƤ줿ʸؤΥݥ
 */
TFS_DECLARE(char *) tfs_psprintf(tfs_pool_t *pool, const char *fmt, ...)
		__attribute__((format(printf,2,3)));

/**
 * ¿ťå򥷥󥰥륹åˤ.
 *
 * @param pool tfs_pool_t *
 * @param str const char *
 * @return char * Ѵʸ
 */
TFS_DECLARE(char *) tfs_no2slash(tfs_pool_t *pool, const char *str);

/**
 * եѥȤΩƤֵѤ.
 *
 * @param pool tfs_pool_t *
 * @param root const char * 롼ȥѥ
 * @param f const char * ˷礹ѥ
 * @param ... Ĺѥ᡼. üɬNULL ˤƲ.
 * @return char * ȤΩƤѥ̾
 */
TFS_DECLARE(char *) tfs_make_full_path(tfs_pool_t *pool, const char *root,
                                       const char *f, ...);

/*------------------------------------------------------------------------------
  Declare public functions 2 (ꥢʤʸ桼ƥƥ)
  ----------------------------------------------------------------------------*/
/**
 * s ʸΥΰҡפ˳ݤƤ򥳥ԡ.
 *
 * ʣ줿ǡɬ̥뽪ü(\0)Ȥʤޤ.
 * ܴؿʣ줿ʸǡϻȤäɬfree()Ʋ.
 *
 * @param s const char * ʸ
 * @return char * ʣ줿ʸؤΥݥ
 *                s NULLǤʣޤ.
 */
TFS_DECLARE(char *) tfs_strdup(const char *s);

/**
 * s ʸΤnʸʬʣƥ̥뽪üֵ.
 * s Ĺn 礭ˤϡtfs_strdup() ƱưȤʤޤ.
 * s Ĺn 硢nʸʬڤäʣޤ.
 *
 * @param s const char * ʸ
 * @param n tfs_size_t ʣʸθĿ(̥뽪üϥȤޤ)
 * @return char * ʣʸؤΥݥ
 *                n == 0s == NULL ξˤʣޤ.
 */
TFS_DECLARE(char *) tfs_strndup(const char *s, tfs_size_t n);

/**
 * ꤵ줿ʣʸϢ뤹.
 *
 * Ϣ뤵줿ʸϥҡפ˥Ȥޤ.
 * ܴؿʣ줿ʸǡϻȤäɬfree()Ʋ.
 * (note)
 *   Ϣνüˤɬ NULL ꤷƲ.
 *   ()
 *       char *s = tfs_strcat("abc", "123", "xxxx", NULL);
 *
 * @param s0 const char * Ƭʸ. 줬NULLϢϤޤ.
 * @param ... (Ĺѥ᡼) ɬʸǤʤФʤޤ.
 *                               Ǥʤˤ˽ޤ.
 * @return char * Ϣ뤷ʸؤΥݥ
 */
TFS_DECLARE(char *) tfs_strcat(const char *s0, ...);

/**
 * ꤵ줿ʣʸnʸʬϢ뤹.
 *
 * ϢĹ n 礭ˤϡtfs_strcat() ƱưȤʤޤ.
 * ϢĹ n ˤϡƬnʸʬʣޤ.
 * ֵѤǡνüɬNULLüȤʤޤ.
 * ܴؿʣ줿ʸǡϻȤäɬfree()Ʋ.
 *
 * @param n tfs_size_t Ϣʸʸ
 * @param s0 const char * Ƭʸ. 줬NULLϢϤޤ.
 * @return char * Ϣ뤷ʸؤΥݥ
 */
TFS_DECLARE(char *) tfs_strncat(tfs_size_t n, const char *s0, ...);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_STRING_H */

