/**
 * $Id: tfs_varray.h 1387 2006-03-06 02:17:52Z takehara $
 *
 * ѥ桼ƥƥ (Array : Ĺ󥳥ƥ)
 */
#ifndef INCLUDE_TFS_VARRAY_H
#define INCLUDE_TFS_VARRAY_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * Ĺɽƥȹ¤ [ Դ ]
 */
typedef struct tfs_varray_t	tfs_varray_t;

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * ꤵ줿ǿsize ĤǤĥݥݻѲĹ.
 * size ϽǤǿ­ʤʤмưŪɲäޤ
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢varray 򥹥åɴ֤Ƕͭʤ¤
 *   åɥդȤʤޤ.
 *
 * @param pool tfs_pool_t * סؤΥݥ
 * @param size tfs_int32_t ǿ
 * @param varray tfs_varray_t ** ĹؤΥݥ
 */
TFS_DECLARE(void) tfs_varray_create(tfs_pool_t *pool,
                                    tfs_int32_t size, tfs_varray_t **varray);

/**
 * Ĺvarray element ֥Ȥɲä.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @param element void * ɲä륪֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_varray_add(tfs_varray_t *varray, void *element);

/**
 * Ĺvarray ΰindex Υ֥Ȥelement ֤.
 * index ϰϳǤв⤷ޤ.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @param index tfs_int32_t ɲð
 * @param element void * ɲä륪֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_varray_set(tfs_varray_t *varray,
                                 tfs_int32_t index, void *element);

/**
 * Ĺvarray ΰindex ˤ륪֥Ȥ֤.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @param index tfs_int32_t 
 * @return void * ֤˳ǼƤ֥ȤؤΥݥ
 */
TFS_DECLARE(void *) tfs_varray_remove(tfs_varray_t *varray, tfs_int32_t index);

/**
 * Ĺvarray ǿ.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @return tfs_int32_t ǿ
 */
TFS_DECLARE(tfs_int32_t) tfs_varray_size(tfs_varray_t *varray);

/**
 * Ĺvarray ΰindex ˤǤ.
 * remove Ȱۤʤꡢindex ֤ǤϽޤ.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @param index tfs_int32_t (0Ϥޤޤ)
 * @return void * index˳ǼƤ֥ȤؤΥݥ
 */
TFS_DECLARE(void *) tfs_varray_get(tfs_varray_t *varray, tfs_int32_t index);

/**
 * Ĺvarray Ǥƥꥢ.
 *
 * Ĺ˳Ǽ줿ȥ֥Ȥ˴ؤƤϲ⤷ޤ.
 * ƤӽФɬפǤŬڤʽλԤäƤ餳δؿƤӽФƲ.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @param index tfs_int32_t (0Ϥޤޤ)
 * @return void * index˳ǼƤ֥ȤؤΥݥ
 */
TFS_DECLARE(void) tfs_varray_clear(tfs_varray_t *varray);

/**
 * Ĺvarray ƤФ.
 * (note)
 * 	ФǤϡtfs_varray_t Фɲáڥ졼
 * 	ԤͤȤʤޤɲáڥ졼󤬼»ܤ
 * 	٤ˡδؿȤäƺƼʤФʤޤ.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 * @return void ** ĹƬؤΥݥ
 */
TFS_DECLARE(void **) tfs_varray_getelements(tfs_varray_t *varray);

/**
 * varray Ĺpool Υΰ˥ԡ.
 * (note)
 *   Ĺ˳Ǽ줿ͤϥԡޤ󡣥ݥ󥿤Ѥޤ.
 *   ʪCloneǤ.
 *
 * @param pool tfs_pool_t *
 * @param varray tfs_varray_t * ԡ
 * @return tfs_varray_t * ʣĹꥹȤؤΥݥ
 */
TFS_DECLARE(tfs_varray_t *) tfs_varray_clone(tfs_pool_t *pool, tfs_varray_t *varray);

/**
 * Ĺvarray ȤƤΰ˴.
 *
 * @param varray tfs_varray_t * ĹؤΥݥ
 */
TFS_DECLARE(void) tfs_varray_destroy(tfs_varray_t *varray);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_VARRAY_H */

