/**
 * $Id: tfs_xml.h 1022 2005-12-31 10:56:34Z takehara $
 *
 * ѥ桼ƥƥ (XML DOM parser : XMLDOM ѡ)
 * (note)
 *   Ǥ줿ϢAPIǤϥ͡ॹڡ򰷤ޤ.
 */
#ifndef INCLUDE_TFS_XML_H
#define INCLUDE_TFS_XML_H

#include "tfs.h"
#include "tfs_errno.h"
#include "tfs_pools.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Define fixed values and macro
  ----------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------
  Declare incomplete type structure
  ----------------------------------------------------------------------------*/
/**
 * XML DOM ѡ򥳥ƥȹ¤ [ Դ ]
 */
typedef struct tfs_xml_parser	tfs_xml_parser;

/**
 * XML Document (XMLɥȥĥ꡼Υ롼) ɽ¤ [ Դ ]
 */
typedef struct tfs_xml_doc	tfs_xml_doc;

/**
 * Text Ρɤɽ¤ [ Դ ]
 */
typedef struct tfs_xml_text	tfs_xml_text;

/*------------------------------------------------------------------------------
  Define structure and enum
  ----------------------------------------------------------------------------*/
typedef struct tfs_xml_elem	tfs_xml_elem;
typedef struct tfs_xml_attr	tfs_xml_attr;

/**
 * XML Element (XMLɥȤ) ɽ¤
 */
struct tfs_xml_elem {
	/* ̾ */
	const char *name;

	/* xml:lang */
	const char *lang;

	/* TextΡ / CDATA Section */
	tfs_xml_text *text;

	/* ° */
	tfs_xml_attr *attr;

	/* Ʊؤˤ륨ȤؤΥݥ(sibling) */
	tfs_xml_elem *next;

	/* child ȤؤΥݥ */
	tfs_xml_elem *first_child;

	/*
	 * ʲϥѡ. DOMΡɤιȤϴطޤ
	 */

	/* parent ȤؤΥݥ */
	tfs_xml_elem *parent;

	/* Ǹ³줿ChildΡɤؤΥݥ */
	tfs_xml_elem *last_child;

	/* ΥȤѡparser ؤΥݥ
	 * (note) Ѥ⥸塼ϤΥФؤΥ϶ػ */
	tfs_xml_parser *parser;
};

/**
 * XML °ɽ¤
 */
struct tfs_xml_attr {
	const char *name;	/* °̾ */
	const char *value;	/*  */

	tfs_xml_attr *next;	/* °ؤΥݥ */
};

/*------------------------------------------------------------------------------
  Declare public function
  ----------------------------------------------------------------------------*/
/**
 * DOM Ρɤ뤿XML ѡ.
 *
 * (note) parser  DOM ΡɤȤδطˤĤ
 *   parser  DOMΡɤȤδط11Ȥʤޤ. 
 *   äƎ$DOMΡɤѡΤ˻Ѥparser ֥Ȥ
 *   ̤DOMΡɲϽѤǤޤ. Ǥ.
 *
 * (note) DOMΡɤΥ饤եˤĤ
 *   parser  DOMΡɤΥ饤եϸ̩˰פޤ.
 *   Τᡢѡλparser˴硢ϤƤDOMΡɤ
 *   ͤȤʤޤ. DOMΡɤ򥳥ԡ뤳ȤϤǤޤΤǡ
 *   ŪˤϡDOMΡɤ˥¤ꡢparser ˴ƤϤʤޤ.
 *
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * (Reentrant)
 *   δؿϥåɥդǤ.¾δؿ⡢parser 򥹥åɴ֤Ƕͭʤ¤
 *   åɥդȤʤޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param parser tfs_xml_parser ** XML DOMѡؤΥݥ
 */
TFS_DECLARE(void) tfs_xml_parser_create(tfs_pool_t *pool, tfs_xml_parser **parser);

/**
 * ꤵ줿եѥpath XMLեѡDOMΡɤۤ.
 * (note)
 *   δؿǤϡtfs_xml_parser_create() XMLѡѤǤޤ.
 *   ܴؿᤵ줿XMLѡȤäDOM ΡɤϽޤ.
 *
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param path const char * XMLեΥեѥ
 * @param parser tfs_xml_parser ** doc ѡXML DOMѡؤΥݥ
 * @param doc tfs_xml_doc ** ѡ̤XML ɥȤؤΥݥ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_xml_parse_file(tfs_pool_t *pool, const char *path,
                                             tfs_xml_parser **parser,
                                             tfs_xml_doc **doc);

/**
 * len Υǡ data XMLǡѡDOMΡɤۤ.
 * (note)
 *   δؿǤϡtfs_xml_parser_create() XMLѡѤǤޤ.
 *   ܴؿᤵ줿XMLѡȤäDOM ΡɤϽޤ.
 *
 * (note)
 *   pool ꤵ줿硢pool ꥢȤʤޤ
 *   δؿ줿󥹥󥹤destroyʤƤ⡢pool ˴줿
 *   ưŪ˴ޤ.
 *
 * @param pool tfs_pool_t * ꥢؤΥݥ
 * @param data const char * XMLǡ
 * @param len tfs_size_t data Ĺ
 * @param parser tfs_xml_parser ** doc ѡXML DOMѡؤΥݥ
 * @param doc tfs_xml_doc ** ѡ̤XML ɥȤؤΥݥ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_xml_parse_data(tfs_pool_t *pool, const char *data,
                                             tfs_size_t len,
                                             tfs_xml_parser **parser,
                                             tfs_xml_doc **doc);

/**
 * ȤΩΥlen Υǡ data XMLǡ XML DOMѡparser 
 * ϤƥѡԤ.
 * δؿƤXMLǡϤޤlen  data˥åȤƸƤǲ.
 * Ϥ顢Ҥؿtfs_xml_parse_done() ¹ԤƲ.
 * (note)
 *   parser ϴؿ tfs_xml_parser_create() ΤȤޤ.
 *
 * @param parser tfs_xml_parser * XML DOMѡؤΥݥ
 * @param data const char * XMLǡ
 * @param len tfs_size_t data Ĺ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_xml_parse_feed(tfs_xml_parser *parser,
                                             const char *data,
                                             tfs_size_t len);

/**
 * tfs_xml_parse_feed Ѥ줿XMLƥѡDOMΡɤۤ.
 * (note)
 *   parser ϴؿ tfs_xml_parser_create() ΤȤޤ.
 *
 * @param parser tfs_xml_parser * XML DOMѡؤΥݥ
 * @param doc tfs_xml_doc ** ѡ̤XML ɥȤؤΥݥ
 * @return tfs_status_t ơ
 */
TFS_DECLARE(tfs_status_t) tfs_xml_parse_done(tfs_xml_parser *parser,
                                             tfs_xml_doc **doc);

/**
 * XML Υѡȯ顼å.
 *
 * @param parser tfs_xml_parser * XML DOMѡؤΥݥ
 * @param rv tfs_status_t 顼ȯΥ顼
 * @return char * 顼åؤΥݥ.
 *                ʸfree() ƤϤʤޤ.
 */
TFS_DECLARE(char *) tfs_xml_geterror(tfs_xml_parser *parser, tfs_status_t rv);

/**
 * DocumentΡɤθǽΥΡ(rootΡ) .
 *
 * @param doc tfs_xml_doc *
 * @return tfs_xml_elem * root ΡɤؤΥݥ
 */
TFS_DECLARE(tfs_xml_elem *) tfs_xml_get_rootnode(const tfs_xml_doc *doc);

/**
 * XML elem TextΡ(CDATAޤ) ֵѤ.
 * (note)
 *   p Ϳ줿硢ͤΥ饤եp ˰פޤ.
 *   p NULLξ硢ͤΥ饤եparser ΤȰפޤ.
 *
 * @param p tfs_pool_t * ѥסؤΥݥ
 * @param elem tfs_xml_elem * ȥ֥
 * @param strip_white int XMLWhiteڡʸ뤫ɤ.
 * @return char * CDATA ؤΥݥ. 饤եelem ƱʤΤ
 *                ɬפǤиƤӽФǥԡѤƲ.
 */
TFS_DECLARE(char *) tfs_xml_get_cdata(tfs_xml_elem *elem, int strip_white, tfs_pool_t *p);

/**
 * XML elem Child tagname Ȱפ륨Ȥ.
 *
 * @param elem tfs_xml_elem * ȥ֥
 * @param tagname const char * ̾
 * @return tfs_xml_elem * ȤؤΥݥ
 */
TFS_DECLARE(tfs_xml_elem *) tfs_xml_find_child(tfs_xml_elem *elem,
                                               const char *tagname);

/**
 * XML DOMѡparser ˴.
 * parser ݻƤڤƤXML Document ˴ؤ
 * ΰޤ.
 * ܴؿƽФ塢parser ˿äƤϤʤޤ.
 *
 * @param parser tfs_xml_parser * XML DOMѡؤΥݥ
 */
TFS_DECLARE(void) tfs_xml_parser_destroy(tfs_xml_parser *parser);

/**
 * ʸs ƥȥΡͤˤݡѤǤʤʸQuote.
 *
 * [ ִʸ ]
 *   * '<'  -->  '&lt;'
 *   * '>'  -->  '&gt;'
 *   * '&'  -->  '&amp;'
 *
 * @param pool tfs_pool_t * ꥢ
 * @param s const char * оʸ
 * @return char * Quote줿ʸؤΥݥ. Ѵɬפ̵Ǥs 
 *                ʣϤޤ.
 */
TFS_DECLARE(char *) tfs_xml_quote_string(tfs_pool_t *pool, const char *s);

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFS_XML_H */

